/* globals for stat program */

#define COLWIDTH 10        // width of each column;
#define EMPTY ""           // empty cell;
#define VERSION "2.4"
#define OUTBUFLEN 100000              /* output buffer for results;  */
#define DATALEN 1000                  /*                             */
#define PRINTCMD "lpr -Ptext "        /* command used for printing   */
#define PRINTDAT "/tmp/xmstat.print"  /* temporary file for printing */

#include <Xm/Xm.h>
#include <Xbae/Matrix.h>

/* Structure for menu system */
typedef struct {
  Widget f_menu;
  Widget n_data;
  Widget l_data;
  Widget s_data;
  Widget c_data;
  Widget quit;
} f_menu;
typedef struct {
  Widget e_menu;
  Widget addrow;
  Widget addrowb;
  Widget addrowa;
  Widget addrowe;
  Widget addcol;
  Widget addcolb;
  Widget addcola;
  Widget addcole;
  Widget cpcol;
  Widget cprow;
  Widget delrow;
  Widget delcol;
  Widget varname;
  Widget varorder;
} e_menu;
typedef struct {
  Widget r_menu;
  Widget clear;
  Widget copy;
  Widget paste;
  Widget transpose;
} r_menu;
typedef struct {
  Widget u_menu;
  Widget sort;
  Widget dep;
  Widget trans;
  Widget trans1;
  Widget trans2;
} u_menu;
typedef struct {
  Widget s_menu;
  Widget list_m;
  Widget mean_m;
  Widget regres_m;
  Widget ttest_m;
  Widget ttpaired_m;
  Widget ttunpaired_m;
  Widget anova1way;
  Widget anova1wayup;
  Widget anova1wayp;
  Widget anova2way;
  Widget anova2waypp;
  Widget anova2waypup;
  Widget anova2wayupup;
  Widget nonpara;
  Widget mannwhitney;
  Widget wilcoxon;
} s_menu;

typedef struct {
    f_menu file;
    e_menu edit;
    r_menu region;
    s_menu stats;
    u_menu utils;
} main_menu;

/* Structure for Toolbar Pushbuttons */
typedef struct {
  Widget open;
  Widget add_col_r;
  Widget add_col_l;
  Widget add_row_top;
  Widget add_row_bot;
  Widget del_row;
  Widget del_col;
} tabline;

/* Structure for marked region */
typedef struct {
  int    row1, col1, row2, col2;
  String *data;
  int    ndata, nrow, ncol;
  short  is_full;
} region;

/* c++ class for sorting */
class sort_class {
  void dep_ok_cb(Widget widget, XtPointer client_data, XtPointer call_data);
public:
  int nsort;            /* Number of sort variables */
  int *sort;            /* points to column numbers of sort variables */
  int ndep;             /* Number of dependent variables */
  int *dep;             /* points to column numbers of dependent variables */
  int ngroup;           /* Number of sorted groups */
  int *group;           /* points to the number of elements in each sort group */
  
       sort_class();    /* constructor */
       ~sort_class();   /* destructor  */
  void del(int col);    /* delete the col-th. sort variable           */
  void add(int col);    /* adds column col to the sort variables      */
  void deldep(int col); /* delete the col-th. dependent variable      */
  void adddep(int col); /* adds column col to the dependent variables */
  void reset_dep();     /* select all possible dependent variables    */
};

/* global variables */
extern XtAppContext  app;
extern main_menu     mymenu;
extern tabline      tabs;
extern Widget        StatData, mess_label;
extern String        colors[];
extern int           last_var_num; /* last variable number used to automatically asign variable names */
extern sort_class    sort;         /* structure used for sorting */
extern region        reg;          /* structure for marked region */
